// Class-42 - Classical inheritance in 42 lines of JavaScript.
var _ = require("underscore");
var slice = Array.prototype.slice;

var extending = false;
var Class = function() {};
_.extend(Class, {
  initialize: function(instance) {
    this.prototype.initialize.apply(instance, slice.call(arguments, 1));
  },
  
  mixin: function(/* modules */) {
    var prototype = this.prototype;
    
    _.each(arguments, function(module) {
      _.extend(prototype, _.isFunction(module) ? module.prototype : module);
    });
  },
  
  extend: function(/* modules, */ prototype) {
    var ctor = function() {
      if (!extending) this.initialize.apply(this, arguments);
    };

    // Import static methods
    _.extend(ctor, this);

    // Set up the prototype chain and instance methods
    try {
      extending = true;
      ctor.prototype = new this();
    } finally {
      extending = false;
    }
    ctor.prototype.constructor = ctor;
    ctor.mixin.apply(ctor, arguments);
    
    return ctor;
  }
});

module.exports = Class;
